package com.engine.salary.service;

import com.engine.salary.entity.progress.ProgressDTO;

import java.math.BigDecimal;

/**
 * 进度条
 * <p>Copyright: Copyright (c) 2022</p>
 * <p>Company: 泛微软件</p>
 *
 * @author qiantao
 * @version 1.0
 **/
public interface ProgressService {

    /**
     * 初始化核算进度条
     *
     * @param salaryAcctProgress
     * @return
     */
    void initProgress(String cacheKey, ProgressDTO salaryAcctProgress);

    /**
     * 更新进度条
     *
     * @param calculatedQuantity
     * @return
     */
    void getAndAddCalculatedQty(String cacheKey, Integer calculatedQuantity);


    /**
     * 更新进度条
     * @param cacheKey
     * @param calculatedQuantity
     * @param message
     */
    void getAndAddCalculatedQty(String cacheKey, Integer calculatedQuantity, String message);

    /**
     * 计算失败
     *
     * @param cacheKey
     * @param message
     * @return
     */
    void fail(String cacheKey, String message);

    /**
     * 完成
     *
     * @param cacheKey
     */
    void finish(String cacheKey, boolean checkStatus);

    /**
     * 完成
     * @param cacheKey
     * @param checkStatus
     * @param message
     */
    void finish(String cacheKey, boolean checkStatus,String message);

    /**
     * 更新进度条
     *
     * @param cacheKey
     */
    void updateProgress(String cacheKey, BigDecimal progress, boolean checkStatus);

    /**
     * 获取进度条
     * @return
     */
    ProgressDTO getProgress(String cacheKey);

    /**
     * 删除redis中的缓存
     *
     * @param cacheKey
     * @return
     */
    ProgressDTO del(String cacheKey);
}
